﻿using System;
using Android.App;
using Android.Content;
using Android.Runtime;
using Android.Views;
using Android.Widget;
using Android.OS;
using Syncfusion.Pdf.Parsing;
using System.IO;
using System.Reflection;
using System.Threading.Tasks;
using Java.IO;
using Syncfusion.Pdf.Graphics;
using Syncfusion.Pdf;

namespace PDFFormTesting
{
    [Activity(Label = "PDFFormTesting", MainLauncher = true, Icon = "@drawable/icon")]
    public class MainActivity : Activity
    {
        int count = 1;

        protected override void OnCreate(Bundle bundle)
        {
            base.OnCreate(bundle);

            // Set our view from the "main" layout resource
            SetContentView(Resource.Layout.Main);

            // Get our button from the layout resource,
            // and attach an event to it
            Button button = FindViewById<Button>(Resource.Id.MyButton);

            button.Click += delegate { GeneratePDF(); };
        }

        void GeneratePDF()
        {
           
            //Create new document
            PdfDocument document = new PdfDocument();

            //Add a page
            PdfPage Page = document.Pages.Add();


            //Load the image in stream
            Stream fStream = typeof(MainActivity).GetTypeInfo().Assembly.GetManifestResourceStream("PDFFormTesting.Assets.animals.jpg");

            //Load the image from the stream.

            PdfBitmap image = new PdfBitmap(fStream);

            //Draw the image

            Page.Graphics.DrawImage(image, 0, 0);

            using (MemoryStream stream = new MemoryStream())
            {

                document.Save(stream);

                Save("sample.pdf", "application/pdf", stream);

            }
        }

        public void  Save(string fileName, String contentType, MemoryStream stream)
        {
            string root = null;
            if (Android.OS.Environment.IsExternalStorageEmulated)
            {
                root = Android.OS.Environment.ExternalStorageDirectory.ToString();
            }
            else
                root = System.Environment.GetFolderPath(System.Environment.SpecialFolder.MyDocuments);

            Java.IO.File myDir = new Java.IO.File(root + "/Syncfusion");
            myDir.Mkdir();

            Java.IO.File file = new Java.IO.File(myDir, fileName);

            if (file.Exists()) file.Delete();

            try
            {
                FileOutputStream outs = new FileOutputStream(file);
                outs.Write(stream.ToArray());

                outs.Flush();
                outs.Close();
            }
            catch (Exception e)
            {

            }
            if (file.Exists())
            {
                Android.Net.Uri path = Android.Net.Uri.FromFile(file);
                string extension = Android.Webkit.MimeTypeMap.GetFileExtensionFromUrl(Android.Net.Uri.FromFile(file).ToString());
                string mimeType = Android.Webkit.MimeTypeMap.Singleton.GetMimeTypeFromExtension(extension);
                Intent intent = new Intent(Intent.ActionView);
                intent.SetDataAndType(path, mimeType);
                this.StartActivity(Intent.CreateChooser(intent, "Choose App"));

            }
        }
    }
}

